%
%               
%

% $Log: codar.m,v $
% Revision 1.1  2000/09/19 20:50:41  kwoklin
% First toolbox internal release.   klee
%

% $Id: codar.m,v 1.1 2000/09/19 20:50:41 kwoklin Exp $
% klee 09/2000
% klee 07/28/2000

GetFunctionName = 'getjgsta';         
CatalogServer = 'http://dods.gso.uri.edu/cgi-bin/nph-ff/catalog/codar.dat';
Cat_m_File = 'gbcat';
URL_m_File = 'gburl';

% VARIABLES -- REQUIRED
LonRange = [-75 -71];
LatRange = [35 42];
TimeRange = [2000.0 2000.5];
DepthRange = [0 0];
DepthUnits = '';

DataName = 'whatever - CODAR - whereever'; 
%%LongitudeName = 'grid_lon';
%%LatitudeName = 'grid_lat';
%%TimeName = 'decimal_day';
DepthName = '';
SelectableVariables = str2mat(str2mat('Surface_Vorticity',...
    'Surface_Divergence','V_Current_Highpassed','U_Current_Highpassed',...
    'V_Current_Lowpassed','U_Current_Lowpassed','V_Current_Detided',...
    'U_Current_Detided'),str2mat('V_Current_Tidal','U_Current_Tidal',...
    'U_Current_Raw','V_Current_Raw'));
DodsName = str2mat(str2mat('s_vorticity','s_diverge','n_highpass',...
                           'e_highpass','n_lowpass','e_lowpass','n_detide',...
                           'e_detide'),str2mat('n_tidal','e_tidal',...
                           'n_raw','e_raw'));
DataNull = [NaN NaN NaN NaN 999 999 999 999 999 999 999 999 ...
                            999 999 999 999];


Acknowledge = [];

% COMMENTS
Comments1 = sprintf('%s\n', ...
'   ', ...
'                              CODAR Data Image ', ...
'   ', ...
'   Parameter         Description                                   Units',...
'   -----------------------------------------------------------------------',...
'   n_raw             Unprocessed, raw surface current - north      m/s  ',...
'   e_raw             Unprocessed, raw surface current - east       m/s  ',...
'   n_tidal           Currents calculated using a least squares     m/s  ',...
'                       fits of the following regional tidal constituents',...
'                       to the raw data.',...
'                         M2 - Half a Lunar Day (Period = 12.42 hours)',...
'                         S2 - Half a Solar Day (Period = 12.00 hours)',...
'                         N2 - Larger Lunar Elliptic (Period = 12.66 hours)',...
'                         K1 - Luni-Solar (Period = 23.93 hours)',...
'                         O1 - A Lunar Day (Period = 25.82 hours)',...
'   e_tidal           (Same as n_tidal - east)                      m/s  ',...
'   n_detide          Currents that result from subtracting the     m/s  ',...
'                       tidal surface currents from the raw surface currents. ',...
'   e_detide          (Same as n_detide - east)',...
'   n_lowpass         Currents calculated by applying a lowpass     m/s  ',...
'                       filter with a cutoff frequency of thirty hours to the ',...
'                       detided velocity field. Therefore the currents contained',...
'                       in this field oscillate with a period greater than thirty hours.',...
'   e_lowpass         (Same as n_lowpass - east)',...
'   n_highpass        Currents that result from subtracting the     m/s  ',...
'                       low-pass filtered surface currents from the detided ',...
'                       surface currents.',...
'   e_highpass        (Same as n_highpass - east)',...
'   s_diverge         The divergence of the low-pass filtered data       ',...
'                       represented by the equivalent vertical velocity assuming',...
'                       a one meter thick surface layer. (Upward velocity indicates',...
'                       divergence and downward velocity indicates convergence.)',...
'   s_vorticity       The vorticity of the low-pass filtered data        ',...
'                       normalized by the local Coriolis paramter(f).');

Comments2 = sprintf('%s\n', ...
'   ', ...
'    Time_Period_of_Content = ', ...
'         Beginning_Date: ', ...
'         Ending_Date: ', ...
'    Spatial_Domain = ', ...
'         Bounding Coordinates: ', ...
'              West Bounding Coordinate: ', ...
'              East Bounding Coordinate: ', ...
'              South Bounding Coordinate: ', ...
'              North Bounding Coordinate: ', ...
'   ', ...
'    Point_of_Contact = ', ...
'         Address: ', ...
'               ', ...
'               ', ...
'               ', ...
'               ', ...
'               ', ...
'               ', ...
'         Electronic Mail Address:INTERNET > support@unidata.ucar.edu ');

Comments = [Comments1 Comments2];

