%
%  GLOBEC Photosynthetically Available Radiation Dataset

% The preceding empty line is important
% $Log: gbpar.m,v $
% Revision 1.1  2000/09/19 20:50:41  kwoklin
% First toolbox internal release.   klee
%

% $Id: gbpar.m,v 1.1 2000/09/19 20:50:41 kwoklin Exp $
% klee 09/2000
% klee 04/1999

GetFunctionName = 'getjgsta';
Server = 'http://dods.gso.uri.edu/cgi-bin/nph-jg/par95'; 
Cat_m_File = 'gbcat';
URL_m_File = 'gburl';

LonRange = [-69.0 -65.6];
LatRange = [40.6 42.4];
%EndTime on last day, slightly larger for floating point comparison
TimeRange = [1995.03013699 1995.42192];
DepthRange = [0.0 63.71];
Resolution = nan;

DodsName = str2mat('par_d','par_platform');
DataName = 'Water Column - Photosynthetically Available Radiation - WHOI/GLOBEC ';    
%%LongitudeName = 'lon';
%%LatitudeName = 'lat';
%%TimeName = str2mat('year_local','month_local','day_local','time_local');
DepthName = 'depth';
DepthUnits = 'Meters';
SelectableVariables = str2mat('PAR_Downwelling','PAR');
OptionalVariables = 'cast';
SelectableOptional = 'Cast';

Acknowledge = [];
Data_Use_Policy = sprintf('%s' ,...
      'Any person making substantial use of a data set must communicate with the investigators who acquired the data prior to publication and anticipate that the data collectors will be co-authors of published results. This extends to model results and to data organized for retrospective studies. (Please refer to U.S. GLOBEC''s data policy Report #10 (http://cbl.umces.edu/fogarty/usglobec/reports/datapol/ datapol.contents.html).) The data available here are intended for scholarly use by the academic and scientific community, with the express understanding that any such use will properly acknowledge the originating investigator. Use or reproduction of any material herein for any commercial purpose is prohibited without prior written permission from the U.S. GLOBEC Georges Bank Data Management Office. (http://globec.whoi.edu/globec-dir/contact_dmo.html)');


%COMMENTS
Comments1 = sprintf('%s\n', ...
'                          Photosynthetically Available Radiation Data  ',...
'   ',...
'                   Parameter         Description                     Units',...
'                 ----------------------------------------------------------',...
'   ',...
'                   cruiseid          Cruise identification           n/a',...
'                   platform          Platform name                   n/a',...
'                   region            Geographical region             n/a',...
'                   station           Station number or identifier    n/a',...
'                   cast              Cast number                     n/a',...
'                   day_local         Local day                       n/a',...
'                   month_local       Local month                     n/a',...
'                   year_local        Local year                      n/a',...
'                   timezone          Time zone                       n/a',...
'                   time_local        Local time                      n/a',...
'                   depth             Depth of sample                 meters',...
'                   par_d             downwelling photosynthetically ',...
'                                     active radiation with cosine ',...
'                                     sensor response                 \muEinstein/m2-sec PAR',...
'                                                                     (400-700nm)',...
'                   par_platform      photosynthetically active ',...
'                                     radiation with cosine sensor',...
'                                     response                        \muEinstein/m2-sec PAR',...
'                                                                     (400-700nm)',...
'                   lat               Latitude                        decimal degrees',...
'                   lon               Longitude                       decimal degrees',...
'  ',...
' ');

Comments2 = sprintf('%s\n',...
'  1.Most information regarding individual profiles is provided with the individual data files (location,',...
'     correction to GMT, light units, sensor type and characteristics, date of latest calibration). ',...
'  2.All profiles were taken with the same two (Biospherical Instruments, Inc. San Diego, CA)',...
'     instruments: underwater unit (PUV-500) and matched deck unit (PUV-510). No replacement',...
'     instruments were needed. ',...
'  3.All profiles were taken from same location on the R/V Endeavor: starboard side using the J-frame.',...
'     Whenever sea condition allowed, the ship was turned such that the sun was shining on the starboard',...
'     side and as close to amidship as possible. ',...
'  4.The December 1995 recalibration results have been applied to all readings. The change in calibrations',...
'     from the previous April 1993 factory measurements were less than 2%. ');

Comments4 = sprintf('%s\n', ...
'   ', ...
'    Time_Period_of_Content = ', ...
'         Beginning_Date: Jan. 12, 1995 (1995.03228155) ', ...
'         Ending_Date:    Jun. 04, 1995 (1995.42328783)', ...
'    Spatial_Domain = ', ...
'         Bounding Coordinates: ', ...
'              West Bounding Coordinate: 68.9588 W ', ...
'              East Bounding Coordinate: 65.7268 W ', ...
'              South Bounding Coordinate: 40.5347 N ', ...
'              North Bounding Coordinate: 42.3192 N ', ...
'   ', ...
'    Point_of_Contact = ', ...
'         Address - si: ', ...
'               Jeffrey Van Keuren', ...
'               WHOI',...
'               MS #35',...
'               171 Oyster Pond Rd.',...
'               Woods Hole, MA 02543-1521',...
'               USA ', ...
'               Electronic Mail Address:INTERNET > jvankeuren@whoi.edu',...
'               FAX: 508-457-2158',...
'         Address - globec: ',...
'               Robert Groman',...
'               Swift House MS# 38',...
'               Woods Hole, MA 02543-1127',...
'               USA ',...
'               Electronic Mail Address:INTERNET > rgroman@whoi.edu',...
'               FAX: (508) 457-2169',...
'         Address - dods: ',...
'               Electronic Mail Address:INTERNET > support@unidata.ucar.edu ');

Comments = [Comments1 Comments2 Comments4];
